#!/bin/bash

set -e
set -o nounset
set -o pipefail

apt update
apt install -y less vim unzip

cd /workspace

git clone https://github.com/vladmandic/automatic
mkdir -p automatic/models/Stable-diffusion \
    automatic/models/LyCORIS \
    automatic/models/Lora \
    automatic/models/VAE \
    automatic/models/embeddings \
    automatic/extensions/

# Download models

pushd /workspace/automatic/models/Stable-diffusion/
curl -# -O -L -J "https://huggingface.co/bluepen5805/blue_pencil/resolve/main/blue_pencil-v10.safetensors"
popd
pushd /workspace/automatic/models/VAE
curl -# -O -L -J "https://civitai.com/api/download/models/80518"
curl -# -O -L -J "https://civitai.com/api/download/models/26689"
popd
pushd /workspace/automatic/models/LyCORIS
# Better hands
curl -# -O -L -J "https://civitai.com/api/download/models/55199"

popd
pushd /workspace/automatic/models/embeddings
curl -# -O -L -J "https://civitai.com/api/download/models/76712"
popd

pushd /workspace/automatic/models/Lora/
curl -# -O -L -J "https://huggingface.co/ashen-sensored/mzpikas_tmnd_enhanced/resolve/main/Silicon-landscape-isolation.safetensors"
curl -# -O -L -J "https://civitai.com/api/download/models/19075"
curl -# -O -L -J "https://civitai.com/api/download/models/62833"
popd

cp ~/*.json /workspace/automatic/
cp ~/*.toml /workspace
cp ~/styles.csv /workspace/automatic/

# Extensions
pushd /workspace/automatic/extensions/
git clone https://github.com/hako-mikan/sd-webui-regional-prompter
git clone https://github.com/hnmr293/sd-webui-cutoff
git clone https://github.com/ctwrs/a1111-sd-webui-tagcomplete
git clone https://github.com/ashen-sensored/sd_webui_SAG
git clone https://github.com/Bing-su/adetailer
git clone https://github.com/adieyal/sd-dynamic-prompts
git clone https://github.com/huchenlei/sd-webui-openpose-editor
git clone https://github.com/hako-mikan/sd-webui-lora-block-weight

popd

cp ~/lbwpresets.txt /workspace/automatic/extensions/sd-webui-lora-block-weight/

# ControlNet


cd /workspace
curl -L -O -J https://github.com/rapiz1/rathole/releases/download/v0.4.8/rathole-x86_64-unknown-linux-gnu.zip
unzip rathole-x86_64-unknown-linux-gnu.zip

nohup /workspace/rathole -c client-local.toml &

cd /workspace/automatic
python launch.py

